Mail::Box::Locker::NFS(3)

NAME
Mail::Box::Locker::NFS - lock a folder with a separate file, NFS-safe

INHERITANCE
 Mail::Box::Locker::NFS
   is a Mail::Box::Locker
   is a Mail::Reporter

SYNOPSIS
  See Mail::Box::Locker

DESCRIPTION
Like the "::DotLock" locker, but then in an NFS-safe fashion. Over NFS, the creation of a file is not atomic. The "::DotLock" locker depends on an atomic "open" system call, hence in not usable to lock a folder which accessed over NFS. The "::NFS" locker is therefore more complicated (so therefore slower), but will work for NFS --and for local disks as well.

Extends "DESCRIPTION" in Mail::Box::Locker.

METHODS
Extends "METHODS" in Mail::Box::Locker.

  Constructors
Extends "Constructors" in Mail::Box::Locker.

$class->new(%options)
    Inherited, see "METHODS" in Mail::Box::Locker

     -Option --Defined in       --Default
      expires  Mail::Box::Locker  1 hour
      file     Mail::Box::Locker  undef
      folder   Mail::Box::Locker  <C<undef>>
      method   Mail::Box::Locker  'NFS'
      timeout  Mail::Box::Locker  10

    expires => $seconds
    file => $file
    folder => $folder
    method => $name|CLASS|\@names
    timeout => $seconds|'NOTIMEOUT'

  Attributes
Extends "Attributes" in Mail::Box::Locker.

$obj->expires( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->filename( [$filename] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->folder( [$folder] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->name()
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->timeout( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

  Locking
Extends "Locking" in Mail::Box::Locker.

$obj->hasLock()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->isLocked()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->lock()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->unlock()
    Inherited, see "Locking" in Mail::Box::Locker

  Error handling
Extends "Error handling" in Mail::Box::Locker.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Box::Locker.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Box::Locker

DIAGNOSTICS

Error: class $package does not implement method $method.
    Fatal error: the specific $package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package. Cast by notImplemented()

Fault: couldn't remove lockfile $file: $!
    Cast by unlock()

Warning: folder $name already locked over NFS.
    Do not try to lock the folder when the application already has the lock: it will give you dead-locks. Cast by lock()

Warning: removed expired lockfile $file.
    A lock $file was found which was older than the expiration period as specified with new(timeout). The lock file was successfully removed. Cast by lock()

Fault: unable to remove expired lockfile $file: $!
    A lock file was found which was older than the expiration period as specified with the new(timeout) option. It is impossible to remove that lock file, so we need to wait until it vanishes by some external cause. Cast by lock()

SEE ALSO
This module is part of Mail-Box version 4.01, built on December 13, 2025. Website: http://perl.overmeer.net/CPAN/

LICENSE
For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.